package eus.urko.appresidencia.android.Adapter;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import java.util.List;
import eus.urko.appresidencia.android.Dominio.Oferta;
import eus.urko.appresidencia.android.R;

// Adaptador de la clase ofertas para cargarla en un RecyclerView
public class OfertasAdapter extends RecyclerView.Adapter<OfertasAdapter.OfertasHolder>{

    // Contexto de la aplicació pasada por parametros
    private Context mContext;
    // Lista con los objetos a cargar
    private List<Oferta> ofertaList;

    // Holder que hace de intermiario con la card
    public class OfertasHolder extends RecyclerView.ViewHolder {
        // Interfaz UI
        private TextView tvTitulo;
        private TextView tvDescripcion;

        public OfertasHolder(View view) {
            super(view);
            tvTitulo = (TextView) view.findViewById(R.id.tvTitulo);
            tvDescripcion = (TextView) view.findViewById(R.id.tvDescripcion);
        }

        public TextView getTvTitulo() {
            return tvTitulo;
        }

        public void setTvTitulo(TextView tvTitulo) {
            this.tvTitulo = tvTitulo;
        }

        public TextView getTvDescripcion() {
            return tvDescripcion;
        }

        public void setTvDescripcion(TextView tvDescripcion) {
            this.tvDescripcion = tvDescripcion;
        }
    }

    // Constructora
    public OfertasAdapter(Context mContext, List<Oferta> ofertaList) {
        this.mContext = mContext;
        this.ofertaList = ofertaList;
    }

    @Override
    public OfertasHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View itemView = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.card_oferta, parent, false);

        return new OfertasHolder(itemView);
    }


    @Override
    public void onBindViewHolder(final OfertasHolder holder, int position) {
        // Obtenemos el objeto a crear
        final Oferta oferta = ofertaList.get(position);

        // Inicializamos la intefaz
        holder.tvTitulo.setText(oferta.getTitulo());
        holder.tvDescripcion.setText(oferta.getDescripcion());
    }

    @Override
    public int getItemCount() {
        return ofertaList.size();
    }


}
