package eus.urko.appresidencia.android.Dialog;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.Window;

import java.util.ArrayList;

import eus.urko.appresidencia.android.Dominio.Alergeno;
import eus.urko.appresidencia.android.Adapter.AlergenoAdapter;
import eus.urko.appresidencia.android.R;

public class AlergenosDialog extends Dialog {

    private Alergeno alergeno;

    public AlergenosDialog(Context context, Alergeno alergeno) {
        super(context, R.style.AppCompatAlertDialogStyle);
        this.alergeno = alergeno;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.dialog_alergeno);


        RecyclerView rvAlergenos = findViewById(R.id.rvAlergenos);

        ArrayList<AlergenoAdapter.ObjectoAuxiliar> objectoAuxiliarList = new ArrayList<>();

        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.altramuz), alergeno.getAltramuz(), R.drawable.altramuz));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.apio), alergeno.getApio(), R.drawable.apio));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.cachuetes), alergeno.getCacahuetes(), R.drawable.cacahuetes));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.cascara), alergeno.getCascara(), R.drawable.frutossecos));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.crustaceos), alergeno.getCrustaceos(), R.drawable.crustaceos));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.gluten), alergeno.getGluten(), R.drawable.gluten));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.huevos), alergeno.getHuevos(), R.drawable.huevo));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.lacteos), alergeno.getLacteos(), R.drawable.lacteos));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.moluscos), alergeno.getMoluscos(), R.drawable.moluscos));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.mostaza), alergeno.getMostaza(), R.drawable.mostaza));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.pescado), alergeno.getPescado(), R.drawable.pescado));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.sesamo), alergeno.getSesamo(), R.drawable.sesamo));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.soja), alergeno.getSoja(), R.drawable.soja));
        objectoAuxiliarList.add(new AlergenoAdapter.ObjectoAuxiliar(getContext().getString(R.string.sulfitos), alergeno.getSulfitos(), R.drawable.sulfitos));


        AlergenoAdapter alergenoAdapter = new AlergenoAdapter(getContext(), objectoAuxiliarList);
        GridLayoutManager mLayoutManagerAlergeno = new GridLayoutManager(getContext(), 3);

        rvAlergenos.setLayoutManager(mLayoutManagerAlergeno);
        rvAlergenos.setItemAnimator(new DefaultItemAnimator());
        rvAlergenos.setAdapter(alergenoAdapter);

    }
}