package eus.urko.appresidencia.android.Dominio;


import android.content.Context;
import android.support.annotation.NonNull;
import android.support.design.widget.Snackbar;
import android.util.Log;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

import eus.urko.appresidencia.android.Dominio.Alergeno;
import eus.urko.appresidencia.android.Dominio.Comida;
import eus.urko.appresidencia.android.Dominio.ComidaAux;
import eus.urko.appresidencia.android.Dominio.Curso;
import eus.urko.appresidencia.android.Dominio.Desayuno;
import eus.urko.appresidencia.android.Dominio.Dia;
import eus.urko.appresidencia.android.Dominio.Oferta;
import eus.urko.appresidencia.android.Dominio.Residencia;
import eus.urko.appresidencia.android.Dominio.Usuario;

public class CargarDominio {

    // CODIGO PARA CREAR OBJETOS
    public static void generarBackend(Context context) {
        FirebaseDatabase database = FirebaseDatabase.getInstance();

        DatabaseReference refUsuarios = database.getReference("usuarios");
        DatabaseReference refResindecias = database.getReference("residencias");
        DatabaseReference refCursos = database.getReference("cursos");
        DatabaseReference refDias = database.getReference("dias");
        DatabaseReference refDesayunos = database.getReference("desayunos");
        DatabaseReference refComidas = database.getReference("comidas");
        DatabaseReference refAlergenos = database.getReference("alergenos");
        DatabaseReference refOfertas = database.getReference("ofertas");

        database.getReference().removeValue();

        // Crear Residencias

        Residencia residenciaMAQ = new Residencia("Manuel Agud Querol",
                "Paseo de Berio 9, Donostia (20018)",
                "943563007",
                "residentes.maq@resa.es",
                "https://www.resa.es/es/residencias/san-sebastian/residencia-universitaria-manuel-agud-querol/residencia/",
                "43.307088",
                "-2.012847");

        String keyMAQ = refResindecias.push().getKey();
        refResindecias.child(keyMAQ).setValue(residenciaMAQ);

        Residencia residenciaBO = new Residencia("Blas de Otero",
                "Cortes 38, Bilbao (48003)",
                "944343200",
                "blasdeotero@resa.es",
                "https://www.resa.es/es/residencias/bilbao/residencia-universitaria-blas-de-otero/residencia/",
                ",-2.012847",
                "-2.930876");

        String keyBO = refResindecias.push().getKey();
        refResindecias.child(keyBO).setValue(residenciaBO);


        // Crear Cursos

        Curso curso1617MAQ = new Curso("2016-2017", keyMAQ);
        String keyCurso1617MAQ = refCursos.push().getKey();
        refCursos.child(keyCurso1617MAQ).setValue(curso1617MAQ);

        Curso curso1718MAQ = new Curso("2017-2018", keyMAQ);
        String keyCurso1718MAQ = refCursos.push().getKey();

        refCursos.child(keyCurso1718MAQ).setValue(curso1718MAQ);


        Curso curso1718BO = new Curso("2017-2018", keyBO);
        String keyCurso1718BO = refCursos.push().getKey();
        refCursos.child(keyCurso1718BO).setValue(curso1718BO);

        // Cargar Usuario
        Usuario usuario = new Usuario(
                "Urko",
                "Lopez de Abetxuko",
                "Ruiz de Mendarozketa",
                1,
                0
        );
        usuario.setIdResidenciaPreferida(keyMAQ);
        usuario.setIdCursoPreferido(keyCurso1718MAQ);
        refUsuarios.child(FirebaseAuth.getInstance().getCurrentUser().getUid()).setValue(usuario);

        // Crear dias y menu dia

        Date date = new Date();
        for(int i = 0; i < 50; i++) {
            String keyDiaMAQ = refDias.push().getKey();
            String keyDesayuno = refDesayunos.push().getKey();
            String keyComida1 = refComidas.push().getKey();
            String keyComida2 = refComidas.push().getKey();

            ArrayList<String> listaIdAlergenosComida1 = new ArrayList<>();
            ArrayList<String> listaIdAlergenosComida2 = new ArrayList<>();

            for (int j = 0; j < 5; j++) {
                String keyAlergeno1 = refAlergenos.push().getKey();
                listaIdAlergenosComida1.add(keyAlergeno1);
                refAlergenos.child(keyAlergeno1).setValue(generarAlergeno(keyComida1));
                String keyAlergeno2 = refAlergenos.push().getKey();
                listaIdAlergenosComida2.add(keyAlergeno2);
                refAlergenos.child(keyAlergeno2).setValue(generarAlergeno(keyComida2));
            }


            Calendar cal = Calendar.getInstance();
            cal.setTime(date);
            int year = cal.get(Calendar.YEAR);
            int month = cal.get(Calendar.MONTH) + 1;
            int day = cal.get(Calendar.DAY_OF_MONTH);

            Dia dia = new Dia(year, month, day, keyMAQ, keyCurso1718MAQ);
            dia.setIdDesayuno(keyDesayuno);
            dia.setIdComida(keyComida1);
            dia.setIdCena(keyComida2);

            Desayuno desayuno = new Desayuno(new ComidaAux("Desayuno"), keyDiaMAQ, keyCurso1718MAQ, keyMAQ);
            Comida comida = generarMenu(false, listaIdAlergenosComida1, keyDiaMAQ, keyCurso1718MAQ, keyMAQ);
            Comida cena = generarMenu(true, listaIdAlergenosComida2, keyDiaMAQ, keyCurso1718MAQ, keyMAQ);

            refDias.child(keyDiaMAQ).setValue(dia);
            refDesayunos.child(keyDesayuno).setValue(desayuno);
            refComidas.child(keyComida1).setValue(comida);
            refComidas.child(keyComida2).setValue(cena);

            date = new Date(date.getTime() + (1000 * 60 * 60 * 24));
        }

        // Ofertas
        ArrayList<Oferta> ofertas = new ArrayList<>();
        ofertas.add(new Oferta("2x1 en bebidas", "Paga sólo la primera", keyCurso1718MAQ, keyMAQ));
        ofertas.add(new Oferta("Trae a un amig@ GRATIS a comer", "Válido los fin de semas. 1 sólo uso.", keyCurso1718MAQ, keyMAQ));
        ofertas.add(new Oferta("Martes dulces", "Todos los martes batido + gofre: 1,50€", keyCurso1718MAQ, keyMAQ));

        for (Oferta oferta : ofertas)
            refOfertas.child(refOfertas.push().getKey()).setValue(oferta);
    }

    final static String[] primerosComida = {"Macarrones carbonara",
            "Pisto",
            "Ensalada de pollo con piña",
            "Coliflor con huevos","Grelos con chorizo",
            "Brécol rehogado",
            "Sopa de fideos",
            "Salteado campestre","Empanadillas de jamón y queso",
            "Gazpacho",
            "Caldo gallego",
            "Tallarines gratinados","Arroz con verduras",
            "Fabada",
            "Lentejas con chorizo",
            "Menestra de verduras","Tallarines a la boloñesa",
            "Coles salteadas",
            "Caldo de repollo",
            "Coliflor rebozada","Tortellini de queso",
            "Crema de grelos",
            "Callos con garbanzos",
            "Espinacas rehogadas","Patatas alioli",
            "Acelgas salteadas"};

    final static String[] segundosComida = {"Aguja en salsa con arroz blanco",
            "Filete de merluza a la plancha",
            "Chuletas a la riojana con puré",
            "Parrochitaas con cachelos","Fideuá de ternera",
            "Merluza a la romana",
            "Pollo asado al horno",
            "Gallitos fritos","Paella",
            "Salmón a la plancha",
            "Zorza",
            "Marrajo a la plancha","Ossobuco en salsa con patatas",
            "Calamares fritos",
            "Pollo en pepitoria",
            "Arroz marinero",
            "Churrasco con cachelos y criollos",
            "Bertorella en salsa",
            "Brochetas a la plancha",
            "Tilapia rebozada","Estofado de pavo",
            "Filetes rellenos",
            "Mendo a la plancha",
            "Albondigas en salsa con arroz blanco",
            "Limanda en salsa"};

    final static String[] postresComida = {"Natillas de galleta",
            "Herradura de crema",
            "Arroz con leche",
            "Helado","Flan",
            "Melocotón en almibar",
            "Natillas","Macedonia de frutas",
            "Mousse de chocolate"};

    final static String[] primerosCena = {"Crema de calabacín",
            "Judías verdes a la gallega",
            "Acelgas gratinadas",
            "Sopa juliana","Crema de verduras",
            "Espinacas con bacon",
            "Croquetas",
            "Guisantes salteados","Ensaladilla",
            "Crema de zanahoria",
            "Sopa de estrellitas",
            "Menestra de verduras","Tosta de atún con tomate",
            "Crema de puerros y zanahoria",
            "Sopa de fideos",
            "Guisantes con jamón","Judías verdes con huevos",
            "Champiñones al ajillo",
            "Ensalada de tomate",
            "Sopa de pescado","Dados de tortilla",
            "Caldo vegetal",
            "Ensalada de pasta vegetal",
            "Crema de calabaza","Sopa de zanahoria",
            "Brecol rehogado"};

    final static String[] segundosCena = {"Pavo a la plancha con patata hervida",
            "Mendo frito",
            "Lomo a la plancha",
            "Bertorella en salsa","Filetes con patata hervida",
            "Revuelto de champiñones",
            "Cinta de lomo en salsa roquefort",
            "Tilapia rebozada","Hot dog",
            "Filete de merluza al vapor con limón",
            "Pechuga de pollo a la plancha",
            "Rapantes fritos","Ternera a la jardinera",
            "Revuelto de jamón y queso",
            "Chuletas a la plancha",
            "Jurelitos fritos","Filetes rusos",
            "Rapantes a la plancha",
            "Arroz con conejo",
            "Filete de merluza a la plancha","Paleta adobada con puré",
            "Salmón a la plancha",
            "Pollo a la plancha con patata herbida",
            "Bacalao a la vizcaína","Raxo",
            "Gallos a la plancha"};

    final static String[] postresCena = {"Fruta",
            "Yogur"};


    private static Comida generarMenu(Boolean isCena, List<String> listaIdAlergenos, String idDia, String idCurso, String idResidencia){
        Iterator<String> i =  listaIdAlergenos.iterator();

        Random random = new Random();

        ComidaAux buffet = new ComidaAux("Ensalada");

        ComidaAux primero1;
        if (isCena) primero1 = new ComidaAux(primerosCena[random.nextInt(primerosCena.length)], i.next());
        else primero1 = new ComidaAux(primerosComida[random.nextInt(primerosComida.length)], i.next());

        ComidaAux primero2;
        if (isCena) primero2 = new ComidaAux(primerosCena[random.nextInt(primerosCena.length)], i.next());
        else primero2 = new ComidaAux(primerosComida[random.nextInt(primerosComida.length)], i.next());

        ComidaAux segundo1;
        if (isCena) segundo1 = new ComidaAux(segundosCena[random.nextInt(segundosCena.length)], i.next());
        else segundo1 = new ComidaAux(segundosComida[random.nextInt(segundosComida.length)], i.next());

        ComidaAux segundo2;
        if (isCena) segundo2 = new ComidaAux(segundosCena[random.nextInt(segundosCena.length)], i.next());
        else segundo2 = new ComidaAux(segundosComida[random.nextInt(segundosComida.length)], i.next());

        ComidaAux postre;
        if (isCena) postre = new ComidaAux(postresCena[random.nextInt(postresCena.length)], i.next());
        else postre = new ComidaAux(postresComida[random.nextInt(postresComida.length)], i.next());


        return new Comida(buffet, primero1, primero2, segundo1, segundo2, postre, idDia, idCurso, idResidencia);
    }

    private static Alergeno generarAlergeno(String idComida) {
        Random random = new Random();
        return new Alergeno(random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                random.nextBoolean(),
                idComida);
    }

}
