package eus.urko.appresidencia.android.Fragments;

import android.content.Context;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TabHost;
import android.widget.TextView;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.ValueEventListener;

import eus.urko.appresidencia.android.Activity.MainActivity;
import eus.urko.appresidencia.android.Dominio.Residencia;
import eus.urko.appresidencia.android.R;


public class InformacionFragment extends Fragment {

    private OnFragmentInteractionListener mListener;

    // TAG para identificar el fragment
    private static final String TAG = "InformacionFragment";

    // Referencias UI
    private View viewFragment;
    private TextView tvNombre;
    private TextView tvEmail;
    private TextView tvDireccion;
    private TextView tvTelefono;
    private TextView tvWeb;

    public InformacionFragment() {
        // Required empty public constructor
    }

    public static InformacionFragment newInstance(String param1, String param2) {
        InformacionFragment fragment = new InformacionFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Cargar referencias UI
        viewFragment = inflater.inflate(R.layout.fragment_informacion, container, false);
        tvNombre = (TextView) viewFragment.findViewById(R.id.tvNombre);
        tvEmail = (TextView) viewFragment.findViewById(R.id.tvEmail);;
        tvDireccion = (TextView) viewFragment.findViewById(R.id.tvDireccion);
        tvTelefono = (TextView) viewFragment.findViewById(R.id.tvTelefono);
        tvWeb = (TextView) viewFragment.findViewById(R.id.tvWeb);

        // Cargar datos de la residencia y mostrarlos en la interfaz
        MainActivity.refResindecias.child(MainActivity.usuario.getIdResidenciaPreferida()).addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if (dataSnapshot.exists()) {
                    Residencia residencia = dataSnapshot.getValue(Residencia.class);
                    tvNombre.setText(residencia.getNombre());
                    tvEmail.setText(residencia.getEmail());
                    tvDireccion.setText(residencia.getDireccion());
                    tvTelefono.setText(residencia.getTelefono());
                    tvWeb.setText(residencia.getWeb());
                }

            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });


        return viewFragment;
    }

    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    public interface OnFragmentInteractionListener {
        void onFragmentInteraction(Uri uri);
    }
}
