package eus.urko.appresidencia.android.Fragments;

import android.content.Context;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;

import org.w3c.dom.Text;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import eus.urko.appresidencia.android.Adapter.OfertasAdapter;
import eus.urko.appresidencia.android.Dominio.Oferta;
import eus.urko.appresidencia.android.Activity.MainActivity;
import eus.urko.appresidencia.android.R;


public class OfertasFragment extends Fragment {
    private OnFragmentInteractionListener mListener;

    // TAG para identificar el fragment
    private static final String TAG = "OfertasFragment";

    // Referencias UI
    private View viewFragment;
    private RecyclerView rvOfertas;

    // Adaptadores y arrays de las comidas
    private OfertasAdapter ofertasAdapter;
    private List<Oferta> ofertaList;

    public OfertasFragment() {
        // Required empty public constructor
    }

    public static OfertasFragment newInstance(String param1, String param2) {
        OfertasFragment fragment = new OfertasFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        // Cargar referencias UI
        viewFragment = inflater.inflate(R.layout.fragment_ofertas, container, false);
        rvOfertas = (RecyclerView) viewFragment.findViewById(R.id.rvOfertas);

        // Query de las ofertas
        Query query = MainActivity.refOfertas.
                orderByChild("idCursoidResidencia").
                equalTo(MainActivity.usuario.getIdCursoPreferido() + MainActivity.usuario.getIdResidenciaPreferida());

        // Obtener las ofertas
        query.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if (dataSnapshot.exists()) {
                    Iterator<DataSnapshot> data = dataSnapshot.getChildren().iterator();
                    List<Oferta> ofertaList = new ArrayList<>();
                    while (data.hasNext()){

                        ofertaList.add(data.next().getValue(Oferta.class));
                    }

                    // Cargarlas con el adaptador
                    OfertasAdapter ofertasAdapter = new OfertasAdapter(getContext(), ofertaList);
                    GridLayoutManager mLayoutManagerDesayuno = new GridLayoutManager(getContext(), 1);
                    rvOfertas.setLayoutManager(mLayoutManagerDesayuno);
                    rvOfertas.setItemAnimator(new DefaultItemAnimator());
                    rvOfertas.setAdapter(ofertasAdapter);
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {
            }
        });

        return viewFragment;
    }

    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }


    public interface OnFragmentInteractionListener {
        void onFragmentInteraction(Uri uri);
    }
}
