package eus.urko.appresidencia.android.Fragments;

import android.content.Context;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.google.firebase.database.ChildEventListener;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import eus.urko.appresidencia.android.Activity.MainActivity;
import eus.urko.appresidencia.android.Adapter.PeticionesAdapter;
import eus.urko.appresidencia.android.Dominio.Takeaway;
import eus.urko.appresidencia.android.R;

public class PeticionesFragment extends Fragment {
    private OnFragmentInteractionListener mListener;

    // TAG para identificar el fragment
    private static final String TAG = "PeticionesFragment";

    // Referencias UI
    private View viewFragment;
    private RecyclerView rvPeticiones;

    // Adaptadores y arrays de las comidas
    private PeticionesAdapter peticionesAdapter;
    private List<Takeaway> takeawayList;
    private List<String> idTakeawayList;


    public PeticionesFragment() {
        // Required empty public constructor
    }

    public static PeticionesFragment newInstance(String param1, String param2) {
        PeticionesFragment fragment = new PeticionesFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Cargar referencias UI
        viewFragment = inflater.inflate(R.layout.fragment_peticiones, container, false);
        rvPeticiones = (RecyclerView) viewFragment.findViewById(R.id.rvPeticiones);

        // Inicializar los array list
        takeawayList = new ArrayList<>();
        idTakeawayList = new ArrayList<>();

        // Inicializar el adapatador
        peticionesAdapter = new PeticionesAdapter(getContext(), takeawayList, idTakeawayList);
        GridLayoutManager mLayoutManagerDesayuno = new GridLayoutManager(getContext(), 1);
        rvPeticiones.setLayoutManager(mLayoutManagerDesayuno);
        rvPeticiones.setItemAnimator(new DefaultItemAnimator());
        rvPeticiones.setAdapter(peticionesAdapter);

        // Query para obtener las peticiones
        Query query = MainActivity.refTakeaway.
                orderByChild("idUseridCursoidResidencia").
                equalTo(MainActivity.firebaseUser.getUid() + MainActivity.usuario.getIdCursoPreferido() + MainActivity.usuario.getIdResidenciaPreferida());

        // Cargar de la base de datos las peticiones
        query.addChildEventListener(new ChildEventListener() {
            @Override
            public void onChildAdded(DataSnapshot dataSnapshot, String s) {
                if (dataSnapshot.exists()) {
                    idTakeawayList.add(dataSnapshot.getKey());
                    takeawayList.add(dataSnapshot.getValue(Takeaway.class));
                    peticionesAdapter.notifyDataSetChanged();
                }
            }

            @Override
            public void onChildChanged(DataSnapshot dataSnapshot, String s) {
            }

            @Override
            public void onChildRemoved(DataSnapshot dataSnapshot) {
                if (dataSnapshot.exists()) {
                    takeawayList.remove(idTakeawayList.indexOf(dataSnapshot.getKey()));
                    idTakeawayList.remove(dataSnapshot.getKey());
                    peticionesAdapter.notifyDataSetChanged();
                }
            }

            @Override
            public void onChildMoved(DataSnapshot dataSnapshot, String s) {
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {
            }
        });



        return viewFragment;
    }

    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    public interface OnFragmentInteractionListener {
        void onFragmentInteraction(Uri uri);
    }


}
