package eus.urko.appresidencia.android.Fragments;

import android.content.Context;
import android.net.Uri;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RatingBar;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;

import eus.urko.appresidencia.android.Activity.MainActivity;
import eus.urko.appresidencia.android.Dominio.Valoracion;
import eus.urko.appresidencia.android.R;

public class ValorarFragment extends Fragment {
    private OnFragmentInteractionListener mListener;
    // TAG para identificar el fragment
    private static final String TAG = "ValorarFragment";

    // Referencias UI
    private View viewFragment;
    private Button btEnviar;
    private RatingBar rbCalidadComida;
    private RatingBar rbCalidadMenu;
    private RatingBar rbCalidadServicio;
    private EditText etComentario;

    public ValorarFragment() {
        // Required empty public constructor
    }

    public static ValorarFragment newInstance(String param1, String param2) {
        ValorarFragment fragment = new ValorarFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Cargar referencias UI
        viewFragment = inflater.inflate(R.layout.fragment_valorar, container, false);
        btEnviar = (Button) viewFragment.findViewById(R.id.btEnviar);
        rbCalidadComida = (RatingBar) viewFragment.findViewById(R.id.rbCalidadComida);
        rbCalidadMenu = (RatingBar) viewFragment.findViewById(R.id.rbCalidadMenu);
        rbCalidadServicio = (RatingBar) viewFragment.findViewById(R.id.rbCalidadServicio);
        etComentario = (EditText) viewFragment.findViewById(R.id.etComentario);

        // Listener btEnviar
        btEnviar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                // Enviar valoracion
                Valoracion valoracion = new Valoracion(
                        rbCalidadServicio.getRating(),
                        rbCalidadComida.getRating(),
                        rbCalidadMenu.getRating(),
                        etComentario.getText().toString(),
                        "",
                        "",
                        MainActivity.usuario.getIdCursoPreferido(),
                        MainActivity.usuario.getIdResidenciaPreferida()

                );
                String keyValoracion = MainActivity.refValoraciones.push().getKey();
                MainActivity.refValoraciones.child(keyValoracion).setValue(valoracion).addOnCompleteListener(new OnCompleteListener<Void>() {
                    @Override
                    public void onComplete(@NonNull Task<Void> task) {
                        Toast.makeText(getContext(), R.string.valoracion_ok, Toast.LENGTH_SHORT).show();
                    }
                });
            }
        });

        return viewFragment;
    }

    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }


    public interface OnFragmentInteractionListener {
        void onFragmentInteraction(Uri uri);
    }
}
